# Method: projects.locations.hardware.signal

- [HTTP request](https://docs.cloud.google.com/distributed-cloud/connected/latest/docs/reference/hardware/rest/v1alpha/projects.locations.hardware/signal#body.HTTP_TEMPLATE)
- [Path parameters](https://docs.cloud.google.com/distributed-cloud/connected/latest/docs/reference/hardware/rest/v1alpha/projects.locations.hardware/signal#body.PATH_PARAMETERS)
- [Request body](https://docs.cloud.google.com/distributed-cloud/connected/latest/docs/reference/hardware/rest/v1alpha/projects.locations.hardware/signal#body.request_body)
  - [JSON representation](https://docs.cloud.google.com/distributed-cloud/connected/latest/docs/reference/hardware/rest/v1alpha/projects.locations.hardware/signal#body.request_body.SCHEMA_REPRESENTATION)
- [Response body](https://docs.cloud.google.com/distributed-cloud/connected/latest/docs/reference/hardware/rest/v1alpha/projects.locations.hardware/signal#body.response_body)
- [Authorization scopes](https://docs.cloud.google.com/distributed-cloud/connected/latest/docs/reference/hardware/rest/v1alpha/projects.locations.hardware/signal#body.aspect)
- [IAM Permissions](https://docs.cloud.google.com/distributed-cloud/connected/latest/docs/reference/hardware/rest/v1alpha/projects.locations.hardware/signal#body.aspect_1)
- [StateSignal](https://docs.cloud.google.com/distributed-cloud/connected/latest/docs/reference/hardware/rest/v1alpha/projects.locations.hardware/signal#StateSignal)
- [Try it!](https://docs.cloud.google.com/distributed-cloud/connected/latest/docs/reference/hardware/rest/v1alpha/projects.locations.hardware/signal#try-it)

Signals the state of a hardware.

### HTTP request

`POST https://gdchardwaremanagement.googleapis.com/v1alpha/{name=projects/*/locations/*/hardware/*}:signal`

The URL uses [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Path parameters

| Parameters ||
|---|---|
| `name` | `string` Required. The name of the hardware. Format: `projects/{project}/locations/{location}/hardware/{hardware}` |

### Request body

The request body contains data with the following structure:

| JSON representation |
|---|
| ``` { "requestId": string, "stateSignal": enum (`https://docs.cloud.google.com/distributed-cloud/connected/latest/docs/reference/hardware/rest/v1alpha/projects.locations.hardware/signal#StateSignal`), "operationType": enum (`https://docs.cloud.google.com/distributed-cloud/connected/latest/docs/reference/hardware/rest/v1alpha/ResourceOperation#Type`), "reTurnupRequired": boolean } ``` |

| Fields ||
|---|---|
| `requestId` | `string` Optional. An optional unique identifier for this request. See [AIP-155](https://google.aip.dev/155). |
| `stateSignal` | ``enum (`https://docs.cloud.google.com/distributed-cloud/connected/latest/docs/reference/hardware/rest/v1alpha/projects.locations.hardware/signal#StateSignal`)`` Optional. Specifies the state signal to send for this hardware. |
| `operationType` | ``enum (`https://docs.cloud.google.com/distributed-cloud/connected/latest/docs/reference/hardware/rest/v1alpha/ResourceOperation#Type`)`` Optional. Specifies the operation type to signal the state for. If the type is not specified, the signal is assumed to be for the initial provisioning. |
| `reTurnupRequired` | `boolean` Optional. Indicates whether a re-turnup is needed when finalizing a repair process. |

### Response body

If successful, the response body contains an instance of `https://docs.cloud.google.com/distributed-cloud/connected/latest/docs/reference/hardware/rest/v1alpha/projects.locations.operations#Operation`.

### Authorization scopes

Requires the following OAuth scope:

- `https://www.googleapis.com/auth/cloud-platform`

For more information, see the [Authentication Overview](https://docs.cloud.google.com/docs/authentication#authorization-gcp).

### IAM Permissions

Requires the following [IAM](https://cloud.google.com/iam/docs) permission on the `name` resource:

- `gdchardwaremanagement.hardware.update`

For more information, see the [IAM documentation](https://cloud.google.com/iam/docs).

## StateSignal

Valid state signals for a hardware.

| Enums ||
|---|---|
| `STATE_SIGNAL_UNSPECIFIED` | State signal of the hardware is unspecified. |
| `READY_FOR_PROVISIONING` | Hardware is ready for provisioning. |